package org.apidesign.cloneproblem;

import java.util.Date;
import junit.framework.TestCase;

/** Test that would be written by the API hacker.
 *
 * @author Jaroslav Tulach <jaroslav.tulach@apidesign.org>
 */
public class ExploitTest extends TestCase {
    public ExploitTest(String name) {
        super(name);
    }

    public void testExploitOverridableClone() {
        try {
            HackedDate now = new HackedDate();
            HackedDate later = new HackedDate(now.getTime() + 1000);
            
            Interval interval = new Interval(now, later);
            assertEquals("1s", 1000, interval.getLength());
            
            fail("And I hoped NullPointerException will be thrown!");
        }  catch (NullPointerException ex) {
            // success, the quest is to generate NullPointerException!
        }
    }

    // BEGIN: interval.exploit
    private static class HackedDate extends Date {
        public HackedDate() {
        }

        public HackedDate(long date) {
            super(date);
        }

        @Override
        public Object clone() {
            return null;
        }
    }
    // END: interval.exploit
}
